<?php
/*************************************************************************/
/* respic                                                                */
/* Author : cidrolin (cidrolin -at- cidrolin.net)                        */
/*                                                                       */
/* script : respic.php                                                   */
/* functionalities :                                                     */
/*     - stand-alone picture resizing script                             */
/*                                                                       */
/* (c) Cidrolin, 2006                                                    */
/*************************************************************************/

/*************************************************************************/
/* This program is free software; you can redistribute it and/or modify  */
/* it under the terms of the GNU General Public License as published by  */
/* the Free Software Foundation; either version 2 of the License, or     */
/* (at your option) any later version.                                   */
/*************************************************************************/

define('IN_SA',true) ;
$inc_path = "." ;
include($inc_path . "/include/ftpl.php") ;

/*********************************************************************************************/
// general constant definitions imported for down-graded stand-alone module
define("SEARCH_ENGINE_FRIENDLY_URLS", 100) ;	// generates urls with slashes	
define("NORMAL_GET_METHOD_URLS", 101) ;			// generates  normal GET queries
define("SESSION_METHOD_GET", 100) ;				// used in functions. Script doesn't maintain sessions.
define("SESSION_METHOD_COOKIE", 101) ;			// id.
define("RESIZE_FULLSIZE_DISPLAY", true) ;		// true iif full size display is to be resized (client side)

define("URL_SEP_","_");

/*********************************************************************************************/
// general config variables imported for down-graded stand-alone module
$conf['basedir']    	= "/respic/" ;
$conf['url_type']		= NORMAL_GET_METHOD_URLS ;	
$conf['template']		= "./templates/" ;

$default['sep']     	= "_" ;

$meta['subject']      	= "pic_reduce 0.5" ;	// provided by TOPIC record
$meta['description']  	= "pic_reduce 0.5" ;	// provided by TOPIC record
$meta['rating']       	= "general" ;
$meta['keywords']     	= "" ;
$meta['expires']      	= "never" ;
$meta['revisiting']   	= "60 days" ;
$meta['robots']       	= "all" ;

/*********************************************************************************************/
// config variables for gallery module
$gallery['path']   = "temp/" ;			// path to picture files (relative to site root, no leading slash)
$gallery['th_w']   = 300 ;				// max dimension of thumbnails (pixels)
$gallery['qual']   = 75 ;				// quality level of thumb (% - 75 = max)
/********************************************************************************************/

/********************************************************************************************/
// dedicated texts for display. These are the values to change to localize the script.

$litteral['gallery']      = "picture resizing utility" ;
$litteral['upload']       = "load a picture" ;
$litteral['submit']       = "submit" ;
$litteral['r_title']      = "resized picture" ;
/********************************************************************************************/


function initializeTpl()
{
	global $tpl_path;

    $tpl = &new FastTemplate($tpl_path);
	$tpl->define(array(
		m_form    => "pic_load.dwt",
		m_page    => "header.dwt"));
	return $tpl;
}
//end fct initializeTpl()


function img_accept($handle)
// checks whether submitted image is acceptable, then file into temp dir.
{
	global $conf, $gallery;
	
	if ( ! $img_data = getimagesize($_FILES[$handle]['tmp_name']) )
	{
		$error = 1 ;
	}
	else
	{
		$filename = basename($_FILES[$handle]['tmp_name']) . strrchr($_FILES[$handle]['name'], ".") ;
		$dest_path = $conf['basedir'] . $gallery['path'] ;
		$ok = move_uploaded_file($_FILES[$handle]['tmp_name'], $_SERVER['DOCUMENT_ROOT'] . $dest_path . $filename);
		chmod($_SERVER['DOCUMENT_ROOT'] . $dest_path . $filename, 0644) ;
		$_SESSION['filename'] = $filename ;
		$_SESSION['dim_value'] = ( $_POST['dim_value'] ) ? $_POST['dim_value'] : $gallery['th_w'] ;
		$_SESSION['dim'] = $_POST['dim'] ;

		$src_width  = $img_data[0];
		$src_height = $img_data[1];
		$_SESSION['img_type'] = $img_data[2];
		switch ( $_POST['dim'] )
		{
			case 'w':
			$coeff = $_POST['dim_value'] / $src_width ;
			break ;
			case 'h':
			$coeff = $_POST['dim_value'] / $src_height ;
			break;
		}
		( $coeff < 1 ) ? 1 : $coeff = 1 ;	// do not change size if image is smaller than thumb
		$_SESSION['dest_width']  = floor($src_width  * $coeff) ;
		$_SESSION['dest_height'] = floor($src_height * $coeff);
		$_SESSION['src_width']   = $src_width ;
		$_SESSION['src_height']  = $src_height ;

		$error = 0 ;
	}
	return $error ;
}
// end fct img_accept()


function resize($filename, $dim = NULL, $dim_value = 0)
// function tests whether installed version of graphic library handles GIF or PNG files; JPEG are supposed to be ok
// program-generated thumbnail is always JPEG
{
	global $conf, $gallery;
	
	if ( ( is_null($dim) ) || ( $dim_value == 0 ) )
	{
		$make_thumb = TRUE ;
		$dim_value = $gallery['th_w'] ;
		$dim = "w" ;
	}
	else
	{
		$make_thumb = FALSE ;
	}
	//$make_thumb = TRUE ;
	$img_full = $_SERVER['DOCUMENT_ROOT'] . $conf['basedir'] . $gallery['path'] . $filename ;
	$thb_full = $_SERVER['DOCUMENT_ROOT'] . $conf['basedir'] . $gallery['path'] . "th_" . $filename ;
	
	if ( $img_data = getimagesize($img_full) )
	{
		$src_width  = $img_data[0];
		$src_height = $img_data[1];
		$img_type   = $img_data[2];
		switch ( $dim )
		{
			case 'w':
			$coeff = $dim_value / $src_width ;
			break ;
			case 'h':
			$coeff = $dim_value / $src_height ;
			break;
		}
		( $coeff < 1 ) ? 1 : $coeff = 1 ;	// do not change size if image is smaller than thumb
		$dest_width  = floor($src_width  * $coeff) ;
		$dest_height = floor($src_height * $coeff);
		
		switch ($img_type)
		{
			case 1:		// GIF
				if (function_exists("imagecreatefromgif"))
				{
					$src_img = imagecreatefromgif($img_full);
					$success = true;
				}
				else
				{
					$success = false;
				}
				break;
			case 2:		// JPG
				$src_img = imagecreatefromjpeg($img_full) ;
				$success = true ;
				break;
			case 3:		// PNG
				if (function_exists("imagecreatefrompng"))
				{
					$src_img = imagecreatefrompng($img_full) ;
					$success = true ;
				}
				else
				{
					$success = false;
				}
				break;
		}
		if ( $success )
		{
			$dst_img = imagecreatetruecolor($dest_width, $dest_height) ;
			$white = imagecolorallocate($dst_img, 255, 255, 255) ;
			imagefill($dst_img, 0, 0, $white) ;
			imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $dest_width, $dest_height, $src_width, $src_height);
		
			if ( $make_thumb )
			{
				imagejpeg($dst_img, $thb_full, '75') ;
			}
			else
			{
				header("Content-type: image/jpeg") ;
				imagejpeg($dst_img) ;
			}

			imagedestroy($src_img) ;
			imagedestroy($dst_img) ;
		}
		unlink($img_full) ;
	}
	else
	{
		// non supported file type (perhaps not graphic...)
		$success = false;
	}
	
	return $success;
}
// end fct resize()


function get_image($url, $msg)
{
	global $conf, $gallery, $litteral ;
	
	$tpl = initializeTpl();
	
	$max_filesize = ini_get("upload_max_filesize") ;
	if ( substr($max_filesize, (strlen($max_filesize) - 2)) == "K" )
	{
		$coeff = 1000 ;
	}
	else
	{
		$coeff = 1000000;
	}
	
	$action = $_SERVER['PHP_SELF'] ;
	$tpl->assign(array(
		T_load_form_title => $litteral['upload'] . " (max. " . ini_get("upload_max_filesize"). ")",
		T_action          => $action,
		T_val_maxsize     => $coeff * ini_get("upload_max_filesize"),
		T_dim_value       => $gallery['th_w'],
		T_btn_submit      => $litteral['submit'],
		T_dflt_width      => $gallery['th_w'])) ;
	$tpl->parse(T_submit_form, "m_form") ;
	
	( strlen($dir_link) ) ? $tpl->assign(T_short, "<ul>" . $dir_link . "</ul>") : $tpl->assign(T_short, "<td></td>") ;
	
	$tpl->parse(T_content, "m_form") ;
	
	$tpl->assign(array(
		Meta_rating           => $meta['rating'],
		Meta_keywords         => $meta['keywords'],
		Meta_expires          => $meta['expires'],
		Meta_revisiting_after => $meta['revisiting'],
		Meta_robots           => $meta['robots'],
		T_page_title          => $litteral['gallery'])) ;
	$tpl->parse(TOTAL, "m_page") ;
	
	header("status: 200 OK") ;
	$tpl->FastPrint(TOTAL) ;
}
// end fct get_image()


function show_resized()
// will display resized pic in website graphic environment for right-click download
{
	global $conf, $gallery, $litteral ;
	global $L_submit, $L_msg, $L_msg_sys, $L_gallery, $L_upload;

    $tpl = new FastTemplate("./templates/");

    $tpl->define(array(
		m_page    => "header.dwt",
		m_pic     => "pic_full.dwt"));
	
	switch($_SESSION['dim'])
	{
		case 'w':
		$dim_lib = " (width : " . $_SESSION['dim_value'] ;
		break ;
		case 'h':
		$dim_lib = " (height : " . $_SESSION['dim_value'] ;
		break ;
	}
	
	$tpl->assign(array(
		T_page_title          => $litteral['gallery'],
		Meta_subject          => "picture resizing utility", 
		Meta_description      => "picture resizing utility",
		T_col_w               => $_SESSION['dest_width'] + 20,
		T_src_type            => "",
		T_src_w               => $_SESSION['src_width'],
		T_src_h               => $_SESSION['src_height'],
		T_dst_type            => "jpeg",
		T_dst_w               => $_SESSION['dest_width'],
		T_dst_h               => $_SESSION['dest_height'],
		T_backlink            => $action,
		T_title               => $litteral['r_title'] . $dim_lib . " pixels)",
		T_pic_src             => $_SERVER['PHP_SELF'] . "?filename=" . $_SESSION['filename'],	// filename added to prevent client picture caching
		T_pic_dim             => "width='" . $_SESSION['dest_width'] . "' height='" . $_SESSION['dest_height'] . "'"));
	$tpl->parse(T_content, "m_pic");
	$tpl->parse(TOTAL, "m_page") ;

	header("status: 200 OK");
	$tpl->FastPrint(TOTAL);
}
// end fct show_resized()


function show_msg($error)
{
	echo "error : ",$error,"<br />" ;
}
/*******************************************************************************************************/
// main code

session_start() ;

if ( isset($_GET['filename']) )
{
	// this is called to fill the src param value of img tag in show_resized template
	$filename  = $_SESSION['filename'] ;
	$dim       = $_SESSION['dim'] ;
	$dim_value = $_SESSION['dim_value'] ;
	$_SESSION = array() ;
	if ( isset($_COOKIE['PHPSESSID']) ) 
	{
		setcookie(session_name(), '', time()-42000, '/') ;
	}
	session_destroy() ;
	resize($filename, $dim, $dim_value) ;
}
else if ( isset($_POST['pic_load']) )
	{
		$error = img_accept("upload_img") ;
		if ( $error )
		{
			show_msg($error) ;
			$_SESSION = array() ;
			if ( isset($_COOKIE['PHPSESSID']) ) 
			{
				setcookie(session_name(), '', time()-42000, '/');
			}
			session_destroy() ;
		}
		else
		{
			session_write_close() ;
			show_resized() ;
		}
	}
	else
	{
		$this_script = $_SERVER['PHP_SELF'] ;
		$tpl_path= "./templates/" ;
		get_image($url, $msg) ;
	}

exit() ;

?>
